"use strict";

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.array.from.js");

require("core-js/modules/es.function.name.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.autoTitle = exports.autoTitleFromEntry = void 0;

require("core-js/modules/es.string.split.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.array.slice.js");

require("core-js/modules/es.array.join.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.string.starts-with.js");

require("core-js/modules/es.string.replace.js");

var _global = _interopRequireDefault(require("global"));

var _path = _interopRequireDefault(require("path"));

var _startCase = _interopRequireDefault(require("lodash/startCase"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toArray(arr) { return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var _global$FEATURES = _global.default.FEATURES,
    FEATURES = _global$FEATURES === void 0 ? {} : _global$FEATURES,
    _global$STORIES = _global.default.STORIES,
    STORIES = _global$STORIES === void 0 ? [] : _global$STORIES;

var autoTitleV2 = function autoTitleV2(meta, fileName) {
  return meta.title;
};

var stripExtension = function stripExtension(titleWithExtension) {
  var parts = titleWithExtension.split('/');
  var last = parts[parts.length - 1];
  var dotIndex = last.indexOf('.');
  var stripped = dotIndex > 0 ? last.substr(0, dotIndex) : last;
  parts[parts.length - 1] = stripped;

  var _parts = parts,
      _parts2 = _toArray(_parts),
      first = _parts2[0],
      rest = _parts2.slice(1);

  if (first === '') {
    parts = rest;
  }

  return parts.join('/');
};

var startCaseTitle = function startCaseTitle(title) {
  return title.split('/').map(_startCase.default).join('/');
};

var autoTitleFromEntry = function autoTitleFromEntry(fileName, entry) {
  var _ref = entry.specifier || {},
      directory = _ref.directory,
      _ref$titlePrefix = _ref.titlePrefix,
      titlePrefix = _ref$titlePrefix === void 0 ? '' : _ref$titlePrefix;

  if (fileName.startsWith(directory)) {
    var suffix = fileName.replace(directory, '');
    return startCaseTitle(stripExtension(_path.default.join(titlePrefix, suffix)));
  }

  return undefined;
};

exports.autoTitleFromEntry = autoTitleFromEntry;

var autoTitleV3 = function autoTitleV3(meta, fileName) {
  if (meta.title) return meta.title;

  for (var i = 0; i < STORIES.length; i += 1) {
    var title = autoTitleFromEntry(fileName, STORIES[i]);
    if (title) return title;
  }

  return undefined;
};

var autoTitle = FEATURES.previewCsfV3 ? autoTitleV3 : autoTitleV2;
exports.autoTitle = autoTitle;